#include <stdlib.h>
#include <stdio.h>
#include <strings.h>
#include <time.h>
#include <windows.h>
#include "misc.h"
#include "globals.h"

char *explode_filename(char *fn,time_t t,char *buffer)
{
	tm *info;
	static time_t last_time;
	if (t>=0) // if parameter t<0 use the time from last call
	{
		info=localtime(&t);
		last_time=t;
	}
	else 
	{
		info=localtime(&last_time);
	}
	
	char *c=fn,token;
	buffer[0]='\0';
	
	do
	{
		if (*c=='%')
		{
			token=*(++c);
			
			char buf[33];
			
			switch (token)
			{
				case '%':
					strcat(buffer,"%");
				break;	
				
				case 'y':
					sprintf(buf,"%04d",info->tm_year+1900);
					strcat(buffer,buf);
				break;	
				
				case 'm':
					sprintf(buf,"%02d",info->tm_mon+1);
					strcat(buffer,buf);
				break;	
				
				case 'd':
					sprintf(buf,"%02d",info->tm_mday);
					strcat(buffer,buf);
				break;	
			}
		}
		else
		{
			char temp[2];
			temp[0]=*c;
			temp[1]='\0';
			strcat(buffer,temp);
		}
	}
	while (*c++);
	
	return buffer;
}

static int _wait=0;

void addtolog(int i,char *msg) 
{
	if (logfile)
	{
		while (_wait) Sleep(20);
		_wait=1; // No simultaneous writes
		
		char temp_path[MAX_PATH],temp_path2[MAX_PATH];
		time_t r=time(NULL);
		
		if (r==-1) r=0; // Something was wrong, -1 would lead into bigger trouble
	 
		FILE *logfile=fopen(make_workpath_file(explode_filename(logfilename,r,temp_path),temp_path2),"at");
	    char tmp[1000];
	    
	    strcpy(tmp,asctime(localtime(&r)));
	    tmp[strlen(tmp)-1]='\0';
	    fprintf(logfile,"%s (%d) %s\n",tmp,i,msg);
	    fclose(logfile);
	    _wait=0;
	}
}

